import * as knex from 'knex';
import { Trilogy } from '.';
import Model from './model';
import * as types from './types';
export declare function parseResponse(contents: types.SqlJsResponse): types.LooseObject[];
export declare function buildOrder(partial: knex.QueryBuilder, order: string | [string] | [string, string]): knex.QueryBuilder;
export declare function buildWhere(partial: knex.QueryBuilder, where: types.WhereClause | types.WhereMultiple | undefined, inner?: boolean): knex.QueryBuilder;
export declare function isWhereTuple(where: any): where is types.WhereTuple;
export declare function isWhereMultiple(where: any): where is types.WhereMultiple;
export declare function isValidWhere(where: any): where is types.WhereClause;
export declare function runQuery(instance: Trilogy, query: types.Query, needResponse?: boolean): Promise<any>;
export declare function findLastObject<D extends types.ReturnDict = types.LooseObject>(model: Model<D>, object: types.LooseObject): Promise<D | undefined>;
