import * as types from './types';
export declare function eachObj<T extends types.LooseObject>(collection: T, fn: (value: T[keyof T], key: keyof T) => any): void;
export declare function mapObj<T extends types.LooseObject, R extends T>(collection: T, fn: (value: T[keyof T], key: keyof T) => R): R;
export declare const isObject: (value: any) => value is Record<string, any>;
export declare const isFunction: (value: any) => value is Function;
export declare const isString: (value: any) => value is string;
export declare const isNumber: (value: any) => value is number;
export declare const isNil: (value: any) => value is null | undefined;
export declare const toArray: <T>(value: T | T[]) => T[];
export declare const defaultTo: <T, V>(value: T | null | undefined, fallback: V) => T | V;
export declare type Falsy = false | null | undefined | 0 | '';
export declare function invariant(condition: Falsy, message?: string): never;
export declare function invariant<T>(condition: T, message?: string): T;
export declare function makeDirPath(path: string): boolean;
